diff --git a/game/client/src/main/java/net/minecraft/client/render/shader/ShadersRenderer.java b/game/client/src/main/java/net/minecraft/client/render/shader/ShadersRenderer.java
index d40b63b47..9e056fdec 100644
--- a/game/client/src/main/java/net/minecraft/client/render/shader/ShadersRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/shader/ShadersRenderer.java
@@ -4,31 +4,29 @@ import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.option.enums.CloudQuality;
-import net.minecraft.client.render.FrameBuffer;
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.OpenGLHelper;
 import net.minecraft.client.render.Renderer;
 import net.minecraft.client.render.camera.CameraUtil;
 import net.minecraft.client.render.renderer.Shaders;
-import net.minecraft.client.render.texture.Texture;
+import net.minecraft.client.render.shader.framebuffer.*;
 import net.minecraft.core.block.material.Materials;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.joml.Vector2i;
+import org.joml.Vector2ic;
 import org.lwjgl.opengl.GL41;
 import org.slf4j.Logger;
 
 import java.io.File;
+import java.util.Objects;
 
 public class ShadersRenderer implements Renderer {
     private static final Logger LOGGER = LogUtils.getLogger();
     public Minecraft mc;
 
-    protected final FrameBuffer worldFramebuffer = new FrameBuffer();
-    protected final Texture worldFramebufferColor = new Texture();
-    protected final Texture worldFramebufferDepth = new Texture();
-    protected int worldRenderBufferObject = 0;
-
-    protected final FrameBuffer gameFramebuffer = new FrameBuffer();
-    protected final Texture gameFramebufferColor = new Texture();
-    protected int gameRenderBufferObject = 0;
+    protected @Nullable FrameBuffer worldFrameBuffer = null;
+    protected @Nullable FrameBuffer gameFrameBuffer = null;
 
     protected final Shader postShader = new Shader();
     protected final Shader finalShader = new Shader();
@@ -50,10 +48,13 @@ public class ShadersRenderer implements Renderer {
 
         setupFramebuffer();
 
+        assert this.worldFrameBuffer != null;
+        assert this.gameFrameBuffer != null;
+
         if (this.finalShader.isEnabled()) {
-            this.gameFramebuffer.bind();
+            this.gameFrameBuffer.bind();
         } else {
-            GL41.glBindFramebuffer(GL41.GL_FRAMEBUFFER, 0);
+            this.gameFrameBuffer.unbind();
         }
 
         GL41.glUseProgram(0);
@@ -66,21 +67,30 @@ public class ShadersRenderer implements Renderer {
     public void endRenderGame(float partialTicks) {
         OpenGLHelper.checkError("pre end render game");
 
-        GL41.glViewport(0, 0, this.fbWidth, this.fbHeight);
-        GL41.glBindFramebuffer(GL41.GL_FRAMEBUFFER, 0);
+        assert this.gameFrameBuffer != null;
+
+        this.gameFrameBuffer.blit();
+        final @NotNull FrameBuffer outputBuffer = this.gameFrameBuffer.getOutputBuffer();
 
         if (this.finalShader.isEnabled()) {
             this.finalShader.bind();
 
             GL41.glActiveTexture(GL41.GL_TEXTURE0);
-            this.gameFramebufferColor.bind();
+            Objects.requireNonNull(outputBuffer.getAttachment(FrameBuffer.AttachmentType.COLOR)).bindForOutput();
             this.finalShader.uniformInt("colortex0", 0);
 
             ShaderHelper.setUniforms(this.mc, this.finalShader, partialTicks);
-            ShaderHelper.drawFullscreenRect();
+        } else {
             GL41.glUseProgram(0);
+
+            Objects.requireNonNull(outputBuffer.getAttachment(FrameBuffer.AttachmentType.COLOR)).bindForOutput();
         }
 
+        GL41.glViewport(0, 0, this.fbWidth, this.fbHeight);
+        ShaderHelper.drawFullscreenRect();
+
+        GL41.glUseProgram(0);
+
         OpenGLHelper.checkError("end render game");
     }
 
@@ -88,8 +98,10 @@ public class ShadersRenderer implements Renderer {
     public void beginRenderWorld(float partialTicks) {
         OpenGLHelper.checkError("pre begin render world");
 
+        assert this.worldFrameBuffer != null;
+
         setupFramebuffer();
-        this.worldFramebuffer.bind();
+        this.worldFrameBuffer.bind();
         GL41.glViewport(0, 0, this.renderWidth, this.renderHeight);
 
         GL41.glUseProgram(0);
@@ -101,21 +113,23 @@ public class ShadersRenderer implements Renderer {
     public void endRenderWorld(float partialTicks) {
         OpenGLHelper.checkError("pre end render world");
 
-        if (this.finalShader.isEnabled()) {
-            this.gameFramebuffer.bind();
-        } else {
-            GL41.glBindFramebuffer(GL41.GL_FRAMEBUFFER, 0);
-        }
+        assert this.worldFrameBuffer != null;
+        assert this.gameFrameBuffer != null;
+
+        this.worldFrameBuffer.blit();
+        final @NotNull FrameBuffer outputBuffer = this.worldFrameBuffer.getOutputBuffer();
 
         if (this.postShader.isEnabled()) {
             this.postShader.bind();
 
             GL41.glActiveTexture(GL41.GL_TEXTURE0);
-            this.worldFramebufferColor.bind();
+            Objects.requireNonNull(outputBuffer.getAttachment(FrameBuffer.AttachmentType.COLOR)).bindForOutput();
             this.postShader.uniformInt("colortex0", 0);
+
             GL41.glActiveTexture(GL41.GL_TEXTURE1);
-            this.worldFramebufferDepth.bind();
+            Objects.requireNonNull(outputBuffer.getAttachment(FrameBuffer.AttachmentType.DEPTH)).bindForOutput();
             this.postShader.uniformInt("depthtex0", 1);
+
             GL41.glActiveTexture(GL41.GL_TEXTURE0);
 
             this.mc.ppm.enabled = true;
@@ -123,7 +137,14 @@ public class ShadersRenderer implements Renderer {
             this.mc.ppm.enabled = false;
         } else {
             GL41.glUseProgram(0);
-            this.worldFramebufferColor.bind();
+
+            Objects.requireNonNull(outputBuffer.getAttachment(FrameBuffer.AttachmentType.COLOR)).bindForOutput();
+        }
+
+        if (this.finalShader.isEnabled()) {
+            this.gameFrameBuffer.bind();
+        } else {
+            this.gameFrameBuffer.unbind();
         }
 
         GL41.glViewport(0, 0, this.fbWidth, this.fbHeight);
@@ -132,7 +153,6 @@ public class ShadersRenderer implements Renderer {
         LightmapHelper.instance.enableLightmapRendering();
 
         GL41.glUseProgram(0);
-//        GL41.glEnable(GL41.GL_ALPHA_TEST);
 
         OpenGLHelper.checkError("end render world");
     }
@@ -181,62 +201,69 @@ public class ShadersRenderer implements Renderer {
         int scaledWidth = (int) (renderScale * this.mc.gameWindow.getWidthPixels());
         int scaledHeight = (int) (renderScale * this.mc.gameWindow.getHeightPixels());
 
-        if (this.fbWidth != this.mc.gameWindow.getWidthPixels() || this.fbHeight != this.mc.gameWindow.getHeightPixels() || this.renderWidth != scaledWidth || this.renderHeight != scaledHeight || !this.gameFramebuffer.isGenerated() || !this.worldFramebuffer.isGenerated()) {
-            this.worldFramebuffer.generate();
-            this.worldFramebufferColor.generate();
-            this.worldFramebufferDepth.generate();
-            this.worldRenderBufferObject = GL41.glGenRenderbuffers();
-            this.gameFramebuffer.generate();
-            this.gameFramebufferColor.generate();
-            this.gameRenderBufferObject = GL41.glGenRenderbuffers();
-
+        if (
+            this.worldFrameBuffer == null ||
+            this.gameFrameBuffer == null ||
+            this.fbWidth != this.mc.gameWindow.getWidthPixels() || this.fbHeight != this.mc.gameWindow.getHeightPixels() ||
+            this.renderWidth != scaledWidth || this.renderHeight != scaledHeight
+        ) {
             this.fbWidth = this.mc.gameWindow.getWidthPixels();
             this.fbHeight = this.mc.gameWindow.getHeightPixels();
 
             this.renderWidth = scaledWidth;
             this.renderHeight = scaledHeight;
 
-            boolean filtering = GameSettings.RENDER_SCALE.value.useLinearFiltering;
-            int filterMode = filtering ? GL41.GL_LINEAR : GL41.GL_NEAREST;
-
-            LOGGER.info("Display: {} x {}, Render: {} x {}", this.fbWidth, this.fbHeight, this.renderWidth, this.renderHeight);
-
-            this.worldFramebuffer.bind();
-            this.worldFramebufferColor.bind();
-            GL41.glTexImage2D(GL41.GL_TEXTURE_2D, 0, GL41.GL_RGBA, this.renderWidth, this.renderHeight, 0, GL41.GL_RGBA, GL41.GL_UNSIGNED_BYTE, 0);
-            GL41.glTexParameteri(GL41.GL_TEXTURE_2D, GL41.GL_TEXTURE_MIN_FILTER, filterMode);
-            GL41.glTexParameteri(GL41.GL_TEXTURE_2D, GL41.GL_TEXTURE_MAG_FILTER, filterMode);
-            GL41.glTexParameteri(GL41.GL_TEXTURE_2D, GL41.GL_TEXTURE_WRAP_S, GL41.GL_CLAMP_TO_EDGE);
-            GL41.glTexParameteri(GL41.GL_TEXTURE_2D, GL41.GL_TEXTURE_WRAP_T, GL41.GL_CLAMP_TO_EDGE);
-            GL41.glFramebufferTexture2D(GL41.GL_FRAMEBUFFER, GL41.GL_COLOR_ATTACHMENT0, GL41.GL_TEXTURE_2D, this.worldFramebufferColor.id(), 0);
-
-            this.worldFramebufferDepth.bind();
-            GL41.glTexImage2D(GL41.GL_TEXTURE_2D, 0, GL41.GL_DEPTH_COMPONENT, this.renderWidth, this.renderHeight, 0, GL41.GL_DEPTH_COMPONENT, GL41.GL_FLOAT, 0);
-            GL41.glTexParameteri(GL41.GL_TEXTURE_2D, GL41.GL_TEXTURE_MIN_FILTER, filterMode);
-            GL41.glTexParameteri(GL41.GL_TEXTURE_2D, GL41.GL_TEXTURE_MAG_FILTER, filterMode);
-            GL41.glTexParameteri(GL41.GL_TEXTURE_2D, GL41.GL_TEXTURE_WRAP_S, GL41.GL_CLAMP_TO_EDGE);
-            GL41.glTexParameteri(GL41.GL_TEXTURE_2D, GL41.GL_TEXTURE_WRAP_T, GL41.GL_CLAMP_TO_EDGE);
-
-            GL41.glFramebufferTexture2D(GL41.GL_FRAMEBUFFER, GL41.GL_DEPTH_ATTACHMENT, GL41.GL_TEXTURE_2D, this.worldFramebufferDepth.id(), 0);
-
-//            GL41.glBindRenderbuffer(GL41.GL_RENDERBUFFER, this.worldRenderBufferObject);
-//            GL41.glRenderbufferStorage(GL41.GL_RENDERBUFFER, GL41.GL_DEPTH24_STENCIL8, this.renderWidth, this.renderHeight);
-//            GL41.glFramebufferRenderbuffer(GL41.GL_FRAMEBUFFER, GL41.GL_DEPTH_STENCIL_ATTACHMENT, GL41.GL_RENDERBUFFER, this.worldRenderBufferObject);
-
-            this.gameFramebuffer.bind();
-            this.gameFramebufferColor.bind();
-            GL41.glTexImage2D(GL41.GL_TEXTURE_2D, 0, GL41.GL_RGBA, this.fbWidth, this.fbHeight, 0, GL41.GL_RGBA, GL41.GL_UNSIGNED_BYTE, 0);
-            GL41.glTexParameteri(GL41.GL_TEXTURE_2D, GL41.GL_TEXTURE_MIN_FILTER, filterMode);
-            GL41.glTexParameteri(GL41.GL_TEXTURE_2D, GL41.GL_TEXTURE_MAG_FILTER, filterMode);
-            GL41.glTexParameteri(GL41.GL_TEXTURE_2D, GL41.GL_TEXTURE_WRAP_S, GL41.GL_CLAMP_TO_EDGE);
-            GL41.glTexParameteri(GL41.GL_TEXTURE_2D, GL41.GL_TEXTURE_WRAP_T, GL41.GL_CLAMP_TO_EDGE);
-            GL41.glFramebufferTexture2D(GL41.GL_FRAMEBUFFER, GL41.GL_COLOR_ATTACHMENT0, GL41.GL_TEXTURE_2D, this.gameFramebufferColor.id(), 0);
-
-            GL41.glBindRenderbuffer(GL41.GL_RENDERBUFFER, this.gameRenderBufferObject);
-            GL41.glRenderbufferStorage(GL41.GL_RENDERBUFFER, GL41.GL_DEPTH24_STENCIL8, this.fbWidth, this.fbHeight);
-            GL41.glFramebufferRenderbuffer(GL41.GL_FRAMEBUFFER, GL41.GL_DEPTH_STENCIL_ATTACHMENT, GL41.GL_RENDERBUFFER, this.gameRenderBufferObject);
-
-            GL41.glBindFramebuffer(GL41.GL_FRAMEBUFFER, 0);
+            final boolean filtering = GameSettings.RENDER_SCALE.value.useLinearFiltering;
+            final int filterMode = filtering ? GL41.GL_LINEAR : GL41.GL_NEAREST;
+
+            final @NotNull Vector2ic fbSize = new Vector2i(this.fbWidth, this.fbHeight);
+            final @NotNull Vector2ic renderSize = new Vector2i(this.renderWidth, this.renderHeight);
+
+            LOGGER.info("Display: {}, Render: {}", fbSize, renderSize);
+
+            this.worldFrameBuffer = new FrameBufferSingleSample(
+                new FrameBufferTextureSingleSample(
+                    GL41.GL_RGBA,
+                    GL41.GL_COLOR_ATTACHMENT0,
+                    renderSize,
+                    parameters -> {
+                        parameters.set(GL41.GL_TEXTURE_MIN_FILTER, filterMode);
+                        parameters.set(GL41.GL_TEXTURE_MAG_FILTER, filterMode);
+                        parameters.set(GL41.GL_TEXTURE_WRAP_S, GL41.GL_CLAMP_TO_EDGE);
+                        parameters.set(GL41.GL_TEXTURE_WRAP_T, GL41.GL_CLAMP_TO_EDGE);
+                    }
+                ),
+                new FrameBufferTextureSingleSample(
+                    GL41.GL_DEPTH_COMPONENT,
+                    GL41.GL_DEPTH_ATTACHMENT,
+                    renderSize,
+                    parameters -> {
+                        parameters.set(GL41.GL_TEXTURE_MIN_FILTER, filterMode);
+                        parameters.set(GL41.GL_TEXTURE_MAG_FILTER, filterMode);
+                        parameters.set(GL41.GL_TEXTURE_WRAP_S, GL41.GL_CLAMP_TO_EDGE);
+                        parameters.set(GL41.GL_TEXTURE_WRAP_T, GL41.GL_CLAMP_TO_EDGE);
+                    }
+                )
+            );
+
+            this.gameFrameBuffer = new FrameBufferSingleSample(
+                new FrameBufferTextureSingleSample(
+                    GL41.GL_RGBA,
+                    GL41.GL_COLOR_ATTACHMENT0,
+                    fbSize,
+                    parameters -> {
+                        parameters.set(GL41.GL_TEXTURE_MIN_FILTER, filterMode);
+                        parameters.set(GL41.GL_TEXTURE_MAG_FILTER, filterMode);
+                        parameters.set(GL41.GL_TEXTURE_WRAP_S, GL41.GL_CLAMP_TO_EDGE);
+                        parameters.set(GL41.GL_TEXTURE_WRAP_T, GL41.GL_CLAMP_TO_EDGE);
+                    }
+                ),
+                new RenderBufferSingleSample(
+                    GL41.GL_DEPTH24_STENCIL8,
+                    GL41.GL_DEPTH_STENCIL_ATTACHMENT,
+                    fbSize
+                )
+            );
         }
     }
 
@@ -253,8 +280,9 @@ public class ShadersRenderer implements Renderer {
 
         ShaderProvider shaderProvider = getShader();
 
+        this.finalShader.compile(internal, "post/base");
+
         if (shaderProvider != null) {
-            this.finalShader.compile(shaderProvider, "post/base");
             this.postShader.compile(shaderProvider, "post/post");
         }
 
@@ -263,14 +291,15 @@ public class ShadersRenderer implements Renderer {
 
     @Override
     public void delete() {
-        this.gameFramebuffer.delete();
-        GL41.glDeleteRenderbuffers(this.gameRenderBufferObject);
-        this.gameFramebufferColor.delete();
-
-        this.worldFramebuffer.delete();
-        GL41.glDeleteRenderbuffers(this.worldRenderBufferObject);
-        this.worldFramebufferColor.delete();
-        this.worldFramebufferDepth.delete();
+        if (this.gameFrameBuffer != null) {
+            this.gameFrameBuffer.delete();
+            this.gameFrameBuffer = null;
+        }
+
+        if (this.worldFrameBuffer != null) {
+            this.worldFrameBuffer.delete();
+            this.worldFrameBuffer = null;
+        }
     }
 
     @Override
@@ -287,8 +316,12 @@ public class ShadersRenderer implements Renderer {
         }
     }
 
-    public Texture getWorldFramebufferColor() {
-        return this.worldFramebufferColor;
+    public @Nullable FrameBuffer getWorldFrameBuffer() {
+        return this.worldFrameBuffer;
+    }
+
+    public @Nullable FrameBuffer getGameFrameBuffer() {
+        return this.gameFrameBuffer;
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/render/shader/framebuffer/FrameBuffer.java b/game/client/src/main/java/net/minecraft/client/render/shader/framebuffer/FrameBuffer.java
new file mode 100644
index 000000000..c787d848f
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/shader/framebuffer/FrameBuffer.java
@@ -0,0 +1,183 @@
+package net.minecraft.client.render.shader.framebuffer;
+
+import it.unimi.dsi.fastutil.objects.Object2ObjectArrayMap;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.joml.Vector2i;
+import org.joml.Vector2ic;
+import org.lwjgl.opengl.GL41;
+
+import java.util.Map;
+
+public abstract class FrameBuffer {
+    public enum AttachmentType {
+        COLOR,
+        DEPTH,
+        STENCIL;
+    }
+
+    private final int id;
+    private final @NotNull Map<@NotNull AttachmentType, @NotNull FrameBufferAttachment> attachments = new Object2ObjectArrayMap<>();
+
+    private final @NotNull Vector2ic size;
+
+    private boolean deleted = false;
+
+    protected FrameBuffer(final @NotNull FrameBufferAttachment @NotNull ... attachments) {
+        if (attachments.length == 0) {
+            throw new IllegalArgumentException("Frame buffer must have at least one attachment!");
+        }
+
+        this.size = new Vector2i(attachments[0].getSize());
+        for (int i = 1; i < attachments.length; i++) {
+            if (!this.size.equals(attachments[i].getSize())) {
+                throw new IllegalArgumentException("Size mismatch between attachments 0 and " + i + "!");
+            }
+        }
+
+        final int maxColorAttachments = GL41.glGetInteger(GL41.GL_MAX_COLOR_ATTACHMENTS);
+        for (final @NotNull FrameBufferAttachment attachment : attachments) {
+            final int attachmentTypeId = attachment.getAttachment();
+            if (attachmentTypeId >= GL41.GL_COLOR_ATTACHMENT0 && attachmentTypeId < GL41.GL_COLOR_ATTACHMENT0 + maxColorAttachments) {
+                if (this.attachments.containsKey(AttachmentType.COLOR)) {
+                    throw new IllegalArgumentException("Multiple color attachments!");
+                }
+
+                this.attachments.put(AttachmentType.COLOR, attachment);
+            }
+
+            if (attachmentTypeId == GL41.GL_DEPTH_ATTACHMENT || attachmentTypeId == GL41.GL_STENCIL_ATTACHMENT || attachmentTypeId == GL41.GL_DEPTH_STENCIL_ATTACHMENT) {
+                if (attachmentTypeId == GL41.GL_DEPTH_ATTACHMENT || attachmentTypeId == GL41.GL_DEPTH_STENCIL_ATTACHMENT) {
+                    if (this.attachments.containsKey(AttachmentType.DEPTH)) {
+                        throw new IllegalArgumentException("Multiple depth attachments!");
+                    }
+
+                    this.attachments.put(AttachmentType.DEPTH, attachment);
+                }
+
+                if (attachmentTypeId == GL41.GL_STENCIL_ATTACHMENT || attachmentTypeId == GL41.GL_DEPTH_STENCIL_ATTACHMENT) {
+                    if (this.attachments.containsKey(AttachmentType.STENCIL)) {
+                        throw new IllegalArgumentException("Multiple stencil attachments!");
+                    }
+
+                    this.attachments.put(AttachmentType.STENCIL, attachment);
+                }
+            }
+        }
+
+        this.id = GL41.glGenFramebuffers();
+
+        for (final @NotNull FrameBufferAttachment attachment : attachments) {
+            attachment.attachToFramebuffer(this);
+        }
+    }
+
+    public @Nullable FrameBufferAttachment getAttachment(final @NotNull AttachmentType attachmentType) {
+        return this.attachments.get(attachmentType);
+    }
+
+    public int getId() {
+        if (this.deleted) {
+            throw new IllegalStateException("Frame buffer deleted!");
+        }
+
+        return this.id;
+    }
+
+    public void delete() {
+        if (this.deleted) {
+            throw new IllegalStateException("Frame buffer already deleted!");
+        }
+
+        GL41.glDeleteFramebuffers(this.id);
+        this.deleted = true;
+
+        for (final @NotNull FrameBufferAttachment attachment : this.attachments.values()) {
+            if (!attachment.isDeleted()) {
+                attachment.delete();
+            }
+        }
+    }
+
+    public boolean isDeleted() {
+        return this.deleted;
+    }
+
+    public boolean isComplete() {
+        return GL41.glCheckFramebufferStatus(this.id) == GL41.GL_FRAMEBUFFER_COMPLETE;
+    }
+
+    private void checkComplete() {
+        final int status = GL41.glCheckFramebufferStatus(GL41.GL_FRAMEBUFFER);
+
+        if (status != GL41.GL_FRAMEBUFFER_COMPLETE) {
+            final @NotNull String message = switch (status) {
+                case GL41.GL_FRAMEBUFFER_UNDEFINED -> "GL_FRAMEBUFFER_UNDEFINED: Default framebuffer does not exist!";
+                case GL41.GL_FRAMEBUFFER_INCOMPLETE_ATTACHMENT -> "GL_FRAMEBUFFER_INCOMPLETE_ATTACHMENT: One or more attachment points is incomplete!";
+                case GL41.GL_FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT -> "GL_FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT: Framebuffer does not have at least one image attached!";
+                case GL41.GL_FRAMEBUFFER_INCOMPLETE_DRAW_BUFFER -> "GL_FRAMEBUFFER_INCOMPLETE_DRAW_BUFFER: GL_DRAW_BUFFERi color attachment point is GL_NONE!";
+                case GL41.GL_FRAMEBUFFER_INCOMPLETE_READ_BUFFER -> "GL_FRAMEBUFFER_INCOMPLETE_READ_BUFFER: GL_READ_FRAMEBUFFER color attachment point is GL_NONE!";
+                case GL41.GL_FRAMEBUFFER_UNSUPPORTED -> "GL_FRAMEBUFFER_UNSUPPORTED: Combination of attached images' formats violates implementation-dependent restrictions!";
+                case GL41.GL_FRAMEBUFFER_INCOMPLETE_MULTISAMPLE -> "GL_FRAMEBUFFER_INCOMPLETE_MULTISAMPLE: Inconsistent sampling levels between color and depth attachments!";
+                case GL41.GL_FRAMEBUFFER_INCOMPLETE_LAYER_TARGETS -> "GL_FRAMEBUFFER_INCOMPLETE_LAYER_TARGETS: Inconsistent layering between color and depth attachments!";
+                default -> String.format("0x%04x", status) + ": Unknown framebuffer completion error!";
+            };
+
+            throw new IllegalStateException("Tried using an incomplete frame buffer! Root cause: \"" + message + "\"");
+        }
+    }
+
+    public @NotNull Vector2ic getSize() {
+        if (this.deleted) {
+            throw new IllegalStateException("Frame buffer deleted!");
+        }
+
+        return this.size;
+    }
+
+    public abstract @NotNull FrameBuffer getOutputBuffer();
+
+    public void whileBound(final @NotNull Runnable runnable) {
+        if (this.deleted) {
+            throw new IllegalStateException("Frame buffer deleted!");
+        }
+
+        GL41.glBindFramebuffer(GL41.GL_FRAMEBUFFER, this.id);
+        runnable.run();
+        GL41.glBindFramebuffer(GL41.GL_FRAMEBUFFER, 0);
+    }
+
+    public final void blit() {
+        if (this.deleted) {
+            throw new IllegalStateException("Frame buffer deleted!");
+        }
+
+        this.whileBound(this::checkComplete);
+
+        this.blitInner();
+    }
+
+    public final void bind() {
+        if (this.deleted) {
+            throw new IllegalStateException("Frame buffer deleted!");
+        }
+
+        this.whileBound(this::checkComplete);
+
+        this.bindInner();
+    }
+
+    protected abstract void bindInner();
+
+    public final void unbind() {
+        if (this.deleted) {
+            throw new IllegalStateException("Frame buffer deleted!");
+        }
+
+        this.whileBound(this::checkComplete);
+
+        GL41.glBindFramebuffer(GL41.GL_FRAMEBUFFER, 0);
+    }
+
+    protected abstract void blitInner();
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/shader/framebuffer/FrameBufferAttachment.java b/game/client/src/main/java/net/minecraft/client/render/shader/framebuffer/FrameBufferAttachment.java
new file mode 100644
index 000000000..36dd95815
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/shader/framebuffer/FrameBufferAttachment.java
@@ -0,0 +1,24 @@
+package net.minecraft.client.render.shader.framebuffer;
+
+import org.jetbrains.annotations.NotNull;
+import org.joml.Vector2ic;
+
+public interface FrameBufferAttachment {
+    int getId();
+
+    @NotNull Vector2ic getSize();
+
+    void delete();
+
+    boolean isDeleted();
+
+    void whileBound(final @NotNull Runnable runnable);
+
+    void attachToFramebuffer(final @NotNull FrameBuffer frameBuffer);
+
+    int getAttachment();
+
+    void bindForOutput();
+
+    void unbindForOutput();
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/shader/framebuffer/FrameBufferAttachmentMultiSample.java b/game/client/src/main/java/net/minecraft/client/render/shader/framebuffer/FrameBufferAttachmentMultiSample.java
new file mode 100644
index 000000000..2393cb7fa
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/shader/framebuffer/FrameBufferAttachmentMultiSample.java
@@ -0,0 +1,4 @@
+package net.minecraft.client.render.shader.framebuffer;
+
+public interface FrameBufferAttachmentMultiSample extends FrameBufferAttachment {
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/shader/framebuffer/FrameBufferAttachmentSingleSample.java b/game/client/src/main/java/net/minecraft/client/render/shader/framebuffer/FrameBufferAttachmentSingleSample.java
new file mode 100644
index 000000000..99c49aef3
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/shader/framebuffer/FrameBufferAttachmentSingleSample.java
@@ -0,0 +1,4 @@
+package net.minecraft.client.render.shader.framebuffer;
+
+public interface FrameBufferAttachmentSingleSample extends FrameBufferAttachment {
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/shader/framebuffer/FrameBufferMultiSample.java b/game/client/src/main/java/net/minecraft/client/render/shader/framebuffer/FrameBufferMultiSample.java
new file mode 100644
index 000000000..43f2ab10a
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/shader/framebuffer/FrameBufferMultiSample.java
@@ -0,0 +1,59 @@
+package net.minecraft.client.render.shader.framebuffer;
+
+import org.jetbrains.annotations.NotNull;
+import org.joml.Vector2ic;
+import org.lwjgl.opengl.GL41;
+
+public class FrameBufferMultiSample extends FrameBuffer {
+    final @NotNull FrameBufferSingleSample blitBuffer;
+
+    public FrameBufferMultiSample(final @NotNull FrameBufferAttachmentMultiSample @NotNull ... attachments) {
+        super(attachments);
+
+        this.blitBuffer = new FrameBufferSingleSample(
+            new FrameBufferTextureSingleSample(
+                GL41.GL_RGBA,
+                GL41.GL_COLOR_ATTACHMENT0,
+                this.getSize(),
+                parameters -> {
+                    parameters.set(GL41.GL_TEXTURE_MIN_FILTER, GL41.GL_NEAREST);
+                    parameters.set(GL41.GL_TEXTURE_MAG_FILTER, GL41.GL_NEAREST);
+                    parameters.set(GL41.GL_TEXTURE_WRAP_S, GL41.GL_CLAMP_TO_EDGE);
+                    parameters.set(GL41.GL_TEXTURE_WRAP_T, GL41.GL_CLAMP_TO_EDGE);
+                }
+            ),
+            new FrameBufferTextureSingleSample(
+                GL41.GL_DEPTH_COMPONENT,
+                GL41.GL_DEPTH_ATTACHMENT,
+                this.getSize(),
+                parameters -> {
+                    parameters.set(GL41.GL_TEXTURE_MIN_FILTER, GL41.GL_NEAREST);
+                    parameters.set(GL41.GL_TEXTURE_MAG_FILTER, GL41.GL_NEAREST);
+                    parameters.set(GL41.GL_TEXTURE_WRAP_S, GL41.GL_CLAMP_TO_EDGE);
+                    parameters.set(GL41.GL_TEXTURE_WRAP_T, GL41.GL_CLAMP_TO_EDGE);
+                }
+            )
+        );
+    }
+
+    @Override
+    public @NotNull FrameBuffer getOutputBuffer() {
+        return this.blitBuffer;
+    }
+
+    @Override
+    protected void blitInner() {
+        final @NotNull Vector2ic size = this.getSize();
+
+        GL41.glBindFramebuffer(GL41.GL_READ_FRAMEBUFFER, this.getId());
+        GL41.glBindFramebuffer(GL41.GL_DRAW_FRAMEBUFFER, this.blitBuffer.getId());
+        GL41.glBlitFramebuffer(0, 0, size.x(), size.y(), 0, 0, size.x(), size.y(), GL41.GL_COLOR_BUFFER_BIT, GL41.GL_NEAREST);
+        GL41.glBindFramebuffer(GL41.GL_READ_FRAMEBUFFER, 0);
+        GL41.glBindFramebuffer(GL41.GL_DRAW_FRAMEBUFFER, 0);
+    }
+
+    @Override
+    protected void bindInner() {
+        GL41.glBindFramebuffer(GL41.GL_FRAMEBUFFER, this.getId());
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/shader/framebuffer/FrameBufferSingleSample.java b/game/client/src/main/java/net/minecraft/client/render/shader/framebuffer/FrameBufferSingleSample.java
new file mode 100644
index 000000000..6c05487aa
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/shader/framebuffer/FrameBufferSingleSample.java
@@ -0,0 +1,25 @@
+package net.minecraft.client.render.shader.framebuffer;
+
+import org.jetbrains.annotations.NotNull;
+import org.lwjgl.opengl.GL41;
+
+public class FrameBufferSingleSample extends FrameBuffer {
+    public FrameBufferSingleSample(final @NotNull FrameBufferAttachmentSingleSample @NotNull ... attachments) {
+        super(attachments);
+    }
+
+    @Override
+    protected void blitInner() {
+        // Do nothing
+    }
+
+    @Override
+    protected void bindInner() {
+        GL41.glBindFramebuffer(GL41.GL_FRAMEBUFFER, this.getId());
+    }
+
+    @Override
+    public @NotNull FrameBuffer getOutputBuffer() {
+        return this;
+    }
+}
